import math
from src.geompy.decoCONVERT import easyconvert
import twine

__pi__ = 3.14159
__e__ = 2.71828

def __convertl(iu : float | int, __im__ = None, tm = None) -> str:

    # metric to english =============================
    # cent__im__eters
    if __im__ == 'cm' and tm == 'in': return iu / 2.54
    elif __im__ == 'cm' and tm == 'ft': return iu / 30.48
    elif __im__ == 'cm' and tm == 'mi': return iu / 160934

    # meters
    elif __im__ == 'm' and tm == 'in': return iu * 39.37
    elif __im__ == 'm' and tm == 'ft': return iu * 3.281
    elif __im__ == 'm' and tm == 'mi': return iu / 1609

    #kilometers
    elif __im__ == 'km' and tm == 'in': return iu * 39370
    elif __im__ == 'km' and tm == 'ft': return iu * 3281
    elif __im__ == 'km' and tm == 'mi': return iu / 1.609

    # english to metric =============================
    # inches
    elif __im__ == 'in' and tm == 'cm': return iu * 2.54
    elif __im__ == 'in' and tm == 'm': return iu / 39.37
    elif __im__ == 'in' and tm == 'km': return iu / 1.609

    # feet
    elif __im__ == 'ft' and tm == 'cm': return iu * 30.48
    elif __im__ == 'ft' and tm == 'm': return iu / 3.281
    elif __im__ == 'ft' and tm == 'km': return iu / 3281

    # miles
    elif __im__ == 'mi' and tm == 'cm': return iu * 160934
    elif __im__ == 'mi' and tm == 'm': return iu / 1609
    elif __im__ == 'mi' and tm == 'km': return iu / 1.609


class basic_arith():
    def add_int(args : list[int | float] or tuple(int | float)) -> list[int | float]:
        lst = list(args)[0]

        for x in args[1:]:
            lst += x
        return lst


    def sub_int(args : list[int | float] or tuple(int | float)) -> list[int | float]:
        lst = list(args)[0]

        for x in args[1:]:
            lst -= x
        return lst

    def mult_int(args : list[int | float] or tuple(int | float)) -> list[int | float]:
        lst = list(args)[0]

        for x in args[1:]:
            lst *= x
        return lst

    def div_int(args : list[int | float] or tuple(int | float)) -> list[int | float]:
        lst = list(args)[0]

        for x in args[1:]:
            lst /= x
        return lst


class geom():
    class square():
        @easyconvert
        def sq_a(side : int, convert = None) -> int:
            """
            Multiply the side by the other side to get the area of the square
            """
            return side ** 2

    class trapezoid():
        @easyconvert
        def tpz_a(base1 : float | int, base2 : float | int, height : float | int, convert = None):
            return height * ((base1 + base2) / 2)

        @easyconvert
        def tpz_b(base : float | int, height : float | int, area : float | int, convert = None):
            return 2 * (area / height) - base

        @easyconvert
        def tpz_h(base1 : float | int, base2 : float | int, area : float | int, convert = None):
            return 2 * (area / (base1 + base2))

    class kite():
        @easyconvert
        def kite_a(diagonal1 : float | int, diagonal2 : float | int, convert = None):
            return (diagonal1 * diagonal2) / 2

        @easyconvert
        def kite_d(diagonal : float | int, area : float | int, convert = None): 
            return 2 * (area / diagonal)

    class triangle():
        @easyconvert
        def tri_a(base : float | int, height : float | int, convert = None):
            return (base * height) / 2

        @easyconvert
        def tri_h(area : float | int, base : float | int, convert = None):
            return 2 * (area / base)
    
    class circle():
        def __init__(self):...

        @easyconvert
        def circle_a(radius : float | int, convert = None):
            return __pi__ * (radius ** 2)

        @easyconvert
        def circle_c(radius : float | int, convert = None):
            return 2 * __pi__ * radius

