from dataclasses import dataclass
from src.geompy import __main__ as mnn
from src.geompy import tables as tlb
import unittest   # The test framework

class Test_BasicArithmatic(unittest.TestCase):
    def test_ADDITION(self):
        self.assertEqual(mnn.basic_arith.add_int((4,6,5)), 15)

    def test_ADDITION2(self):
        self.assertEqual(mnn.basic_arith.add_int([9.5,-6.1,5.1]), 8.5)

    def test_SUBTRACTION(self):
        self.assertEqual(mnn.basic_arith.sub_int([10,7,1]), 2)

    def test_SUBTRACTION2(self):
        self.assertEqual(mnn.basic_arith.sub_int((8.8,7.2,6.2)), -4.6)

    def test_MULTIPLICATION(self):
        self.assertEqual(mnn.basic_arith.mult_int([-1,6,12]), -72)


class Test_CentralTendency(unittest.TestCase):
    def test_Mean(self):
        self.assertEqual(tlb.mean([9.5, 27.5, 45.5, 63.5, 81.5, 99.5, 117.5, 135.5], [81, 28, 15, 3, 4, 2, 2, 3]), 25.934782608695652)

    def test_Median(self):
        self.assertEqual(tlb.median(0.5, 18, 81, 138, 0), 15.833333333333332)

        


if __name__ == '__main__':
    unittest.main()